/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the CreateCveRecordResponse type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateCveRecordResponse{}

// CreateCveRecordResponse struct for CreateCveRecordResponse
type CreateCveRecordResponse struct {
	Message *string `json:"message,omitempty"`
	Created *CreateCveRecordResponseCreated `json:"created,omitempty"`
}

// NewCreateCveRecordResponse instantiates a new CreateCveRecordResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateCveRecordResponse() *CreateCveRecordResponse {
	this := CreateCveRecordResponse{}
	return &this
}

// NewCreateCveRecordResponseWithDefaults instantiates a new CreateCveRecordResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateCveRecordResponseWithDefaults() *CreateCveRecordResponse {
	this := CreateCveRecordResponse{}
	return &this
}

// GetMessage returns the Message field value if set, zero value otherwise.
func (o *CreateCveRecordResponse) GetMessage() string {
	if o == nil || IsNil(o.Message) {
		var ret string
		return ret
	}
	return *o.Message
}

// GetMessageOk returns a tuple with the Message field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveRecordResponse) GetMessageOk() (*string, bool) {
	if o == nil || IsNil(o.Message) {
		return nil, false
	}
	return o.Message, true
}

// HasMessage returns a boolean if a field has been set.
func (o *CreateCveRecordResponse) HasMessage() bool {
	if o != nil && !IsNil(o.Message) {
		return true
	}

	return false
}

// SetMessage gets a reference to the given string and assigns it to the Message field.
func (o *CreateCveRecordResponse) SetMessage(v string) {
	o.Message = &v
}

// GetCreated returns the Created field value if set, zero value otherwise.
func (o *CreateCveRecordResponse) GetCreated() CreateCveRecordResponseCreated {
	if o == nil || IsNil(o.Created) {
		var ret CreateCveRecordResponseCreated
		return ret
	}
	return *o.Created
}

// GetCreatedOk returns a tuple with the Created field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveRecordResponse) GetCreatedOk() (*CreateCveRecordResponseCreated, bool) {
	if o == nil || IsNil(o.Created) {
		return nil, false
	}
	return o.Created, true
}

// HasCreated returns a boolean if a field has been set.
func (o *CreateCveRecordResponse) HasCreated() bool {
	if o != nil && !IsNil(o.Created) {
		return true
	}

	return false
}

// SetCreated gets a reference to the given CreateCveRecordResponseCreated and assigns it to the Created field.
func (o *CreateCveRecordResponse) SetCreated(v CreateCveRecordResponseCreated) {
	o.Created = &v
}

func (o CreateCveRecordResponse) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateCveRecordResponse) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Message) {
		toSerialize["message"] = o.Message
	}
	if !IsNil(o.Created) {
		toSerialize["created"] = o.Created
	}
	return toSerialize, nil
}

type NullableCreateCveRecordResponse struct {
	value *CreateCveRecordResponse
	isSet bool
}

func (v NullableCreateCveRecordResponse) Get() *CreateCveRecordResponse {
	return v.value
}

func (v *NullableCreateCveRecordResponse) Set(val *CreateCveRecordResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateCveRecordResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateCveRecordResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateCveRecordResponse(val *CreateCveRecordResponse) *NullableCreateCveRecordResponse {
	return &NullableCreateCveRecordResponse{value: val, isSet: true}
}

func (v NullableCreateCveRecordResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateCveRecordResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


